#!/usr/local/bin/perl -w

use strict;

     use POSIX qw(setsid);
     chdir '/'                 or die "Can't chdir to /: $!";
     umask 0;
     open STDIN, '/dev/null'   or die "Can't read /dev/null: $!";
     #open STDOUT, '>/export/home/lawton/www_docs/cgi/debug.txt' or die "Can't write to /dev/null: $!";
     open STDERR, '>/dev/null' or die "Can't write to /dev/null: $!";
     defined(my $pid = fork)   or die "Can't fork: $!";
     exit if $pid;
     setsid                    or die "Can't start a new session: $!";

	
     while(1) {
        sleep(15);
	my $datadir = "/export/home/lawton/www_docs/cgi";
	my(@users,$line,@users2,$oldtime,$surfer,@uniq,$new) = undef;
	my $newtime = time;
	open(FH, "$datadir/users.txt") || &error("Can't open users.txt");
	@users = (<FH>);
	close(FH);
	foreach (@users){
 	($oldtime,$surfer)=split('\|');
	$oldtime =~ s/ //;
	my $test = $newtime - $oldtime;
	if($test < 61){ push @users2, $surfer; }
	my %seen = ();
	@uniq = ();
	foreach $line (@users2) {push @uniq, $line unless $seen{$line}++;}
	$new = (@uniq);
	open(FH, ">$datadir/users.txt") || &error("Can't open users.txt");
	&lock;
	print FH "";
	close(FH);
	open(FH, ">$datadir/usercount.txt") || &error("Can't open usercount.txt");
	print FH "$new";
	close(FH);

		}
     }

sub error {
print "$_[0]\n";    
}
sub lock {
use Fcntl qw(:flock);
        flock(FH,LOCK_EX);
        seek(FH, 0, 2);
	    }