## This file may be used to convert all perl files from UNIX to 
## MS File format.


use strict;
use File::Basename;
my $this_dir = dirname $0;
opendir DIR, $this_dir or die "opendir $this_dir: $!";
my @files = grep { -f "$this_dir/$_" and (/\.pl$/i or /\.pm$/i)} readdir DIR;
closedir DIR;

foreach my $file (@files) {
  print "Converting file $file from unix to dos..\n";
  open IF, $file    or die "open file $ARGV[0]: $!\n";
  open OF, ">tmp_file" or die "open file $ARGV[1]: $!\n";
  while (<IF>) {
    s/\012$/\n/;
    print OF ;
  }
  close IF or die "file $file: $!";
  close OF or die "file tmp_file: $!";
  rename "tmp_file", $file or die "rename to file $file: $!";
}


